'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _export = require('./export-0fe6e142.js');
require('./array-method-has-species-support-9edd0ecd.js');
require('./object-keys-bdc20d04.js');
require('./web.dom-collections.for-each-e2b90693.js');
require('./create-property-2dfb33b0.js');
require('./array-method-uses-to-length-11844004.js');
require('./web.dom-collections.iterator-4a803988.js');
require('./es.array.concat-2cd183db.js');
require('./es.array.index-of-5554a592.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.function.name-154a69d5.js');
require('./es.object.assign-7fe0379a.js');
require('./es.object.define-property-aad2ae5c.js');
require('./es.object.set-prototype-of-0c1816f8.js');
require('./es.string.match-ce60128e.js');
var React = require('react');
var React__default = _interopDefault(React);
require('./es.promise-14a9b921.js');
require('./species-constructor-ccbb5326.js');
var immutable = require('immutable');
require('react-router-dom');
require('moment');
require('pull-person');
require('pull-person-mobile');
require('qnn-tree');
var index$1 = require('./index-e3be4f77.js');
require('./es.array.map-0663019f.js');
require('antd/es/message/style/css');
require('antd/es/message');
require('./es.array.splice-58c5e38f.js');
require('./style-inject.es-17c48081.js');
require('./es.array.join-78b5edaa.js');
require('antd-mobile/es/toast/style/css');
require('antd-mobile/es/toast');
require('antd/es/notification/style/css');
require('antd/es/notification');
require('antd/es/modal/style/css');
require('antd/es/modal');
require('antd-mobile/es/modal/style/css');
require('antd-mobile/es/modal');
var $ = _interopDefault(require('jquery'));
require('./runtime-72d72705.js');
require('antd/es/skeleton/style/css');
var _Skeleton = _interopDefault(require('antd/es/skeleton'));
require('antd/es/form/style/css');
var _Form = _interopDefault(require('antd/es/form'));
require('antd/es/col/style/css');
var _Col = _interopDefault(require('antd/es/col'));
require('antd/es/button/style/css');
var _Button = _interopDefault(require('antd/es/button'));
var icons = require('@ant-design/icons');
require('antd/es/row/style/css');
var _Row = _interopDefault(require('antd/es/row'));

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

//不可增加的表单块
var FormBlock = function FormBlock(fieldConfig) {
  var style = fieldConfig.style,
      disabled = fieldConfig.disabled,
      formFields = fieldConfig.formFields,
      field = fieldConfig.field,
      _fieldConfig$qnnFormC = fieldConfig.qnnFormConfig,
      qnnFormConfig = _fieldConfig$qnnFormC === void 0 ? {} : _fieldConfig$qnnFormC,
      _fieldConfig$formItem = fieldConfig.formItemLayout,
      formItemLayout = _fieldConfig$formItem === void 0 ? {} : _fieldConfig$formItem,
      label = fieldConfig.label,
      _fieldConfig$labelSty = fieldConfig.labelStyle,
      labelStyle = _fieldConfig$labelSty === void 0 ? {} : _fieldConfig$labelSty,
      _fieldConfig$titleSty = fieldConfig.titleStyle,
      titleStyle = _fieldConfig$titleSty === void 0 ? {} : _fieldConfig$titleSty,
      _fieldConfig$formBloc = fieldConfig.formBlockStyle,
      formBlockStyle = _fieldConfig$formBloc === void 0 ? {} : _fieldConfig$formBloc,
      _fieldConfig$formBloc2 = fieldConfig.formBlockFormStyle,
      formBlockFormStyle = _fieldConfig$formBloc2 === void 0 ? {} : _fieldConfig$formBloc2,
      CreateFormItemEle = fieldConfig.CreateFormItemEle; //兼容写法(不在建议写qnnFormConfig，推荐使用formFields)

  var qnnFormConfig_formConfig = qnnFormConfig.formConfig; //需要处理下表单块中的字段和表单块全局配置

  var fields = (formFields ? formFields : qnnFormConfig_formConfig).map(function (item) {
    item.disabled = item.disabled === false || item.disabled === true ? item.disabled : disabled;
    return item;
  });
  var blockId = "FormBlock_".concat(field); //表单块是否是合拢的 

  var _useState = React.useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      closeed = _useState2[0],
      setCloseed = _useState2[1]; //是否还能手动调用closeFn


  var _useState3 = React.useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      canUsecloseFn = _useState4[0],
      setCanUsecloseFn = _useState4[1];

  React.useEffect(function () {
    if (fieldConfig.closeed && fieldConfig.closeed !== closeed && canUsecloseFn) {
      closeFn();
    }
  });

  var closeFn = function closeFn() {
    setCloseed(!closeed); //只能手动调用一次 调用完就不可以继续调用了

    canUsecloseFn && setCanUsecloseFn(false);
    $("#".concat(blockId)).slideToggle();
  };

  return React__default.createElement("div", {
    style: formBlockStyle,
    className: "".concat(style.qnnFormBlock, " qnnFormBlock ").concat(closeed ? style.qnnFormBlockCloseed + " qnnFormBlockCloseed" : null)
  }, React__default.createElement("div", {
    className: style.formBlockTitle,
    style: titleStyle
  }, React__default.createElement("span", {
    style: labelStyle
  }, label), React__default.createElement("span", {
    onClick: closeFn,
    className: style.rightBtn
  }, closeed ? React__default.createElement("a", null, React__default.createElement(icons.DownOutlined, null), " \u5C55\u5F00") : React__default.createElement("a", null, React__default.createElement(icons.UpOutlined, null), " \u6536\u7F29"))), React__default.createElement("div", {
    id: blockId,
    style: formBlockFormStyle
  }, React__default.createElement(_Row, {
    className: style.row
  }, fields.map(function (childFieldConfig) {
    var _fieldConfig$field, _childFieldConfig$fie;

    var copyFieldConfig = immutable.fromJS(childFieldConfig).toJS();
    !fieldConfig.field && console.error("".concat(label, " \u672A\u914D\u7F6Efield!!!"));
    !childFieldConfig.field && console.error("".concat(childFieldConfig.label, " \u672A\u914D\u7F6Efield!!!"));
    var realField = []; //连接父层field

    realField = realField.concat(Array.isArray(fieldConfig.field) ? fieldConfig.field : (_fieldConfig$field = fieldConfig.field) === null || _fieldConfig$field === void 0 ? void 0 : _fieldConfig$field.split()); //连接子层field

    realField = realField.concat(Array.isArray(childFieldConfig.field) ? childFieldConfig.field : (_childFieldConfig$fie = childFieldConfig.field) === null || _childFieldConfig$fie === void 0 ? void 0 : _childFieldConfig$fie.split());
    return React__default.createElement(CreateFormItemEle, _extends({
      formItemLayout: formItemLayout
    }, copyFieldConfig, {
      field: realField,
      key: "formItem_".concat(realField.join("_"))
    }));
  }))));
};

// `thisNumberValue` abstract operation
// https://tc39.github.io/ecma262/#sec-thisnumbervalue
var thisNumberValue = function (value) {
  if (typeof value != 'number' && _export.classof(value) != 'Number') {
    throw TypeError('Incorrect invocation');
  }
  return +value;
};

// `String.prototype.repeat` method implementation
// https://tc39.github.io/ecma262/#sec-string.prototype.repeat
var stringRepeat = ''.repeat || function repeat(count) {
  var str = String(_export.requireObjectCoercible(this));
  var result = '';
  var n = _export.toInteger(count);
  if (n < 0 || n == Infinity) throw RangeError('Wrong number of repetitions');
  for (;n > 0; (n >>>= 1) && (str += str)) if (n & 1) result += str;
  return result;
};

var nativeToFixed = 1.0.toFixed;
var floor = Math.floor;

var pow = function (x, n, acc) {
  return n === 0 ? acc : n % 2 === 1 ? pow(x, n - 1, acc * x) : pow(x * x, n / 2, acc);
};

var log = function (x) {
  var n = 0;
  var x2 = x;
  while (x2 >= 4096) {
    n += 12;
    x2 /= 4096;
  }
  while (x2 >= 2) {
    n += 1;
    x2 /= 2;
  } return n;
};

var FORCED = nativeToFixed && (
  0.00008.toFixed(3) !== '0.000' ||
  0.9.toFixed(0) !== '1' ||
  1.255.toFixed(2) !== '1.25' ||
  1000000000000000128.0.toFixed(0) !== '1000000000000000128'
) || !_export.fails(function () {
  // V8 ~ Android 4.3-
  nativeToFixed.call({});
});

// `Number.prototype.toFixed` method
// https://tc39.github.io/ecma262/#sec-number.prototype.tofixed
_export.$({ target: 'Number', proto: true, forced: FORCED }, {
  // eslint-disable-next-line max-statements
  toFixed: function toFixed(fractionDigits) {
    var number = thisNumberValue(this);
    var fractDigits = _export.toInteger(fractionDigits);
    var data = [0, 0, 0, 0, 0, 0];
    var sign = '';
    var result = '0';
    var e, z, j, k;

    var multiply = function (n, c) {
      var index = -1;
      var c2 = c;
      while (++index < 6) {
        c2 += n * data[index];
        data[index] = c2 % 1e7;
        c2 = floor(c2 / 1e7);
      }
    };

    var divide = function (n) {
      var index = 6;
      var c = 0;
      while (--index >= 0) {
        c += data[index];
        data[index] = floor(c / n);
        c = (c % n) * 1e7;
      }
    };

    var dataToString = function () {
      var index = 6;
      var s = '';
      while (--index >= 0) {
        if (s !== '' || index === 0 || data[index] !== 0) {
          var t = String(data[index]);
          s = s === '' ? t : s + stringRepeat.call('0', 7 - t.length) + t;
        }
      } return s;
    };

    if (fractDigits < 0 || fractDigits > 20) throw RangeError('Incorrect fraction digits');
    // eslint-disable-next-line no-self-compare
    if (number != number) return 'NaN';
    if (number <= -1e21 || number >= 1e21) return String(number);
    if (number < 0) {
      sign = '-';
      number = -number;
    }
    if (number > 1e-21) {
      e = log(number * pow(2, 69, 1)) - 69;
      z = e < 0 ? number * pow(2, -e, 1) : number / pow(2, e, 1);
      z *= 0x10000000000000;
      e = 52 - e;
      if (e > 0) {
        multiply(0, z);
        j = fractDigits;
        while (j >= 7) {
          multiply(1e7, 0);
          j -= 7;
        }
        multiply(pow(10, j, 1), 0);
        j = e - 1;
        while (j >= 23) {
          divide(1 << 23);
          j -= 23;
        }
        divide(1 << j);
        multiply(1, 1);
        divide(2);
        result = dataToString();
      } else {
        multiply(0, z);
        multiply(1 << -e, 0);
        result = dataToString() + stringRepeat.call('0', fractDigits);
      }
    }
    if (fractDigits > 0) {
      k = result.length;
      result = sign + (k <= fractDigits
        ? '0.' + stringRepeat.call('0', fractDigits - k) + result
        : result.slice(0, k - fractDigits) + '.' + result.slice(k - fractDigits));
    } else {
      result = sign + result;
    } return result;
  }
});

function _slicedToArray$1(arr, i) { return _arrayWithHoles$1(arr) || _iterableToArrayLimit$1(arr, i) || _nonIterableRest$1(); }

function _nonIterableRest$1() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit$1(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles$1(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
// 每个表单内置_id属性为唯一id

var FormBlockCanAdd = function FormBlockCanAdd(props) {
  var form = props.form,
      field = props.field,
      getSetValueFn = props.getSetValueFn,
      fieldsInitialValue = props.fieldsInitialValue,
      setValues = props.fns.setValues;
  var initialValue = props.initialValue; //可以生成表单块id

  var getInitBlockId = function getInitBlockId() {
    return "".concat(new Date().getTime().toString()).concat((Math.random() * 10000 + 100).toFixed(0));
  }; //处理初期値


  var _initialValue = null;

  if (initialValue && initialValue.length) {
    _initialValue = initialValue.map(function (item) {
      item["_id"] = getInitBlockId();
      return _objectSpread({}, fieldsInitialValue, {}, item);
    });
  } else {
    _initialValue = [_objectSpread({
      _id: getInitBlockId()
    }, fieldsInitialValue)];
  } //setValue是设置表单块的值


  var _useState = React.useState(_initialValue),
      _useState2 = _slicedToArray$1(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  React.useEffect(function () {
    //setValues是设置表单的值
    setValues(_defineProperty({}, field, _initialValue));
  }, []); //外部调用这个方法以用于更新表单块value
  //注意：调用这个方法不是覆盖某个字段  而是全部表单块的全部字段

  getSetValueFn(function (value) {
    var _value = value.map(function (item, index) {
      return _objectSpread({}, item, {
        _id: getInitBlockId()
      });
    });

    setValue(_value);
  }); //新增块

  var addBlock = function addBlock() {
    //获取值 
    var fieldVal = form.getFieldValue(field); //合并数据

    var _value = value;

    if (fieldVal) {
      _value = _value.map(function (item, index) {
        if (fieldVal[index]) {
          item = _objectSpread({}, item, {}, fieldVal[index]);
        }

        return item;
      });
    }

    var newVal = _value.concat([_objectSpread({
      _id: getInitBlockId()
    }, fieldsInitialValue)]); //setValue是设置表单块的值
    //setValues是设置表单的值


    setValue(newVal);
    setValues(_defineProperty({}, field, newVal));
  }; //删除块


  var removeBlock = function removeBlock(_ref) {
    var _id = _ref._id;
    var fieldVal = form.getFieldValue(field); //合并数据

    var _value = value;

    if (fieldVal) {
      _value = _value.map(function (item, index) {
        if (fieldVal[index]) {
          item = _objectSpread({}, item, {}, fieldVal[index]);
        }

        return item;
      });
    }

    var deledData = _value.filter(function (item) {
      return item["_id"] !== _id;
    });

    setValue(deledData); //这块需要设置下

    form.setFieldsValue(_defineProperty({}, field, deledData));
  };

  return React__default.createElement("div", null, React__default.cloneElement(React__default.createElement(props.children, null), {
    value: value,
    addBlock: addBlock,
    removeBlock: removeBlock
  }));
};

function _extends$1() { _extends$1 = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends$1.apply(this, arguments); }

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { _defineProperty$1(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty$1(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }
var Buttons = React__default.lazy(function () {
  return new Promise(function (resolve) { resolve(require('./Buttons-ce9555c9.js')); });
});
var DescriptionsForm = React__default.lazy(function () {
  return new Promise(function (resolve) { resolve(require('./DescriptionsForm-dd8ff63b.js')); });
}); //基本表单

var BasicForm = function BasicForm(props) {
  //这里的formItemLayout是顶层form的布局
  var fns = props.fns,
      _props$fns = props.fns,
      setCanAddBlocksUpdateValueFn = _props$fns.setCanAddBlocksUpdateValueFn,
      isMobile = _props$fns.isMobile,
      tool = _props$fns.tool,
      getTabsValueByFetch = _props$fns.getTabsValueByFetch,
      funcCallBackParams = props.funcCallBackParams,
      qnnformData = props.qnnformData,
      tabFormConfig = props.tabFormConfig,
      form = props.form,
      CreateFormItemEle = props.CreateFormItemEle;
  var style = qnnformData.style,
      _qnnformData$field = qnnformData.field,
      field = _qnnformData$field === void 0 ? "basic" : _qnnformData$field,
      _qnnformData$formConf = qnnformData.formConfig,
      formConfig = _qnnformData$formConf === void 0 ? [] : _qnnformData$formConf,
      _qnnformData$tabs = qnnformData.tabs,
      tabs = _qnnformData$tabs === void 0 ? [] : _qnnformData$tabs,
      _qnnformData$btns = qnnformData.btns,
      btns = _qnnformData$btns === void 0 ? [] : _qnnformData$btns,
      formItemLayout = qnnformData.formItemLayout,
      tailFormItemLayout = qnnformData.tailFormItemLayout,
      formType = qnnformData.formType,
      _qnnformData$formCont = qnnformData.formContentScroll,
      formContentScroll = _qnnformData$formCont === void 0 ? true : _qnnformData$formCont,
      antdFormProps = qnnformData.antdFormProps; //说明是tab页面 配置数据需要用tab中的配置

  if (tabFormConfig) {
    formConfig = tabFormConfig.formConfig || [];
    btns = tabFormConfig.btns || [];
    field = tabFormConfig.field;
    formItemLayout = tabFormConfig.formItemLayout || formItemLayout;
    tailFormItemLayout = tabFormConfig.tailFormItemLayout || tailFormItemLayout;
  } //获取到初始值


  var initialValues = index$1.getInitialValues({
    formConfig: _toConsumableArray(immutable.fromJS(formConfig).toJS()),
    fns: fns,
    funcCallBackParams: funcCallBackParams,
    qnnformData: qnnformData,
    tabs: _toConsumableArray(immutable.fromJS(tabs).toJS())
  });
  var ButtonsNode = React__default.createElement(Buttons, {
    qnnformData: qnnformData,
    fns: fns,
    funcCallBackParams: funcCallBackParams,
    btns: btns,
    form: form,
    tailFormItemLayout: tailFormItemLayout
  });

  var formProps = _objectSpread$1({
    name: field,
    form: form,
    ref: function ref() {
      props.getForm(form); //如果是tab表单需要刷新值

      if (tabFormConfig) {
        getTabsValueByFetch();
      }
    },
    initialValues: initialValues,
    className: "".concat(style.form, " qnn-form-form")
  }, formItemLayout, {}, antdFormProps); //渲染描述式表单


  if (formType === 'descriptions') {
    return React__default.createElement(_Form, formProps, React__default.createElement(React.Suspense, {
      fallback: React__default.createElement(_Skeleton, null)
    }, React__default.createElement(DescriptionsForm, _extends$1({}, props, {
      getForm: function getForm() {
        return props.getForm(form);
      }
    })), btns.length ? ButtonsNode : null));
  } // 普通表单


  return React__default.createElement(_Form, formProps, React__default.createElement("div", {
    className: "".concat(style.formContent, " qnn-form-formContent ").concat(formContentScroll === false ? style.formContentNoScroll : null)
  }, React__default.createElement(_Row, {
    className: "".concat(style.row)
  }, formConfig.map(function (fieldConfig) {
    var field = fieldConfig.field,
        label = fieldConfig.label,
        _fieldConfig$labelSty = fieldConfig.labelStyle,
        labelStyle = _fieldConfig$labelSty === void 0 ? {} : _fieldConfig$labelSty,
        _fieldConfig$titleSty = fieldConfig.titleStyle,
        titleStyle = _fieldConfig$titleSty === void 0 ? {} : _fieldConfig$titleSty,
        type = fieldConfig.type,
        canAddForm = fieldConfig.canAddForm,
        formFields = fieldConfig.formFields,
        _fieldConfig$qnnFormC = fieldConfig.qnnFormConfig,
        qnnFormConfig = _fieldConfig$qnnFormC === void 0 ? {} : _fieldConfig$qnnFormC,
        _fieldConfig$textObj = fieldConfig.textObj,
        textObj = _fieldConfig$textObj === void 0 ? {} : _fieldConfig$textObj,
        _fieldConfig$addBtnSt = fieldConfig.addBtnStyle,
        addBtnStyle = _fieldConfig$addBtnSt === void 0 ? {} : _fieldConfig$addBtnSt,
        _fieldConfig$addBtnFo = fieldConfig.addBtnFormItemLayout,
        addBtnFormItemLayout = _fieldConfig$addBtnFo === void 0 ? tailFormItemLayout : _fieldConfig$addBtnFo,
        hide = fieldConfig.hide;

    if (!fieldConfig.formItemLayout) {
      fieldConfig.formItemLayout = qnnFormConfig.formItemLayout;
    }

    var copyFieldConfig = immutable.fromJS(fieldConfig).toJS();

    if (type === "qnnForm" || type === "qnnTable") {
      var realHide = fns.bind(hide)(funcCallBackParams({
        form: form
      }));
      if (realHide) return React__default.createElement("div", {
        key: "formItem_".concat(field, "_Col")
      });
    } //切不可在此将hide字段改为div 否则将获取不到该字段值 


    if (type === "qnnForm") {
      //表单块渲染
      if (!canAddForm) {
        return React__default.createElement(_Col, {
          span: 24,
          key: "formItem_".concat(field, "_Col"),
          className: "".concat(style.formBlockCol)
        }, React__default.createElement(FormBlock, _extends$1({
          style: style,
          CreateFormItemEle: CreateFormItemEle
        }, copyFieldConfig, {
          from: form,
          key: "formItem_".concat(field)
        })));
      } else {
        //兼容写法(不在建议写qnnFormConfig，推荐使用formFields)
        var qnnFormConfig_formConfig = qnnFormConfig.formConfig;
        var fields = formFields ? formFields : qnnFormConfig_formConfig;
        var fieldsInitialValue = fields === null || fields === void 0 ? void 0 : fields.reduce(function (pre, cur) {
          if (cur.initialValue) {
            pre[cur.field] = cur.initialValue;
          }

          return pre;
        }, {});

        var defaultTextObj = _objectSpread$1({
          add: "新增信息",
          del: "删除"
        }, textObj);

        var blockDisabled = copyFieldConfig.disabled;
        return React__default.createElement(_Col, {
          span: 24,
          key: "formItem_".concat(field, "_Col"),
          className: "".concat(style.formBlockCol)
        }, React__default.createElement(FormBlockCanAdd, _extends$1({
          form: form,
          field: field,
          key: "formItem_".concat(field)
        }, copyFieldConfig, {
          //初始值可以initialValues里面去
          initialValue: tool.getDataValByField(field, initialValues) || copyFieldConfig.initialValue //表单块比较特殊的是在设置值时候也需要更新，否则不会主动更新
          //注意：调用这个方法不是覆盖某个字段  而是全部表单块的全部字段
          ,
          getSetValueFn: function getSetValueFn(fn) {
            return setCanAddBlocksUpdateValueFn(field, fn);
          },
          fieldsInitialValue: fieldsInitialValue,
          fns: fns
        }), function (props) {
          var addBlock = props.addBlock,
              removeBlock = props.removeBlock,
              _props$value = props.value,
              value = _props$value === void 0 ? [] : _props$value;
          return React__default.createElement(React__default.Fragment, null, value.map(function (item, index) {
            return React__default.createElement("div", {
              key: item["_id"],
              className: "".concat(style.qnnFormBlock, " qnnFormBlock")
            }, React__default.createElement("div", {
              className: style.formBlockTitle,
              style: titleStyle
            }, React__default.createElement("span", {
              style: labelStyle
            }, label, " ", index + 1), value.length === 1 || blockDisabled ? null : React__default.createElement("span", {
              className: style.delBtn,
              onClick: function onClick() {
                return removeBlock(item);
              }
            }, React__default.createElement(icons.DeleteOutlined, null), " ", defaultTextObj.del)), React__default.createElement(_Row, {
              className: style.row,
              ref: function ref() {
                tool.setInputAlignMiddle();
              }
            }, fields && fields.map(function (childFieldConfig) {
              var copyFieldConfig = immutable.fromJS(childFieldConfig).toJS();
              return React__default.createElement(CreateFormItemEle, _extends$1({}, copyFieldConfig, {
                disabled: copyFieldConfig.disabled || blockDisabled,
                from: form,
                field: [].concat(_toConsumableArray(field.split('.')), [index, childFieldConfig.field]),
                key: "formItem_".concat(field, "_").concat(index, "_").concat(childFieldConfig.field)
              }));
            })));
          }), React__default.createElement(_Form.Item, _extends$1({}, addBtnFormItemLayout, {
            className: "".concat(style.addBlockBtnContainer, " addBlockBtnContainer")
          }), React__default.createElement(_Button, {
            disabled: blockDisabled,
            icon: React__default.createElement(icons.PlusOutlined, null),
            block: isMobile(),
            type: "primary" // ghost
            // type="dashed"
            ,
            style: addBtnStyle,
            onClick: function onClick() {
              return addBlock();
            },
            className: "".concat(style.addBlockBtn, " addBlockBtn")
          }, defaultTextObj.add)));
        }));
      }
    } else {
      return React__default.createElement(CreateFormItemEle, _extends$1({}, copyFieldConfig, {
        from: form,
        key: "formItem_".concat(field)
      }));
    }
  }))), btns.length ? React__default.createElement(React.Suspense, {
    fallback: React__default.createElement(_Skeleton, null)
  }, " ", ButtonsNode, "  ") : null);
};

exports.default = BasicForm;
