'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('./export-0fe6e142.js');
require('./array-method-has-species-support-9edd0ecd.js');
require('./object-keys-bdc20d04.js');
require('./web.dom-collections.for-each-e2b90693.js');
require('./create-property-2dfb33b0.js');
require('./array-method-uses-to-length-11844004.js');
require('./web.dom-collections.iterator-4a803988.js');
require('./es.array.concat-2cd183db.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.object.assign-7fe0379a.js');
require('./es.object.define-property-aad2ae5c.js');
var React = require('react');
var React__default = _interopDefault(React);
var moment = _interopDefault(require('moment'));
require('./es.array.join-78b5edaa.js');
require('antd/es/select/style/css');
var _Select = _interopDefault(require('antd/es/select'));
require('antd-mobile/es/date-picker/style/css');
var _DatePicker2 = _interopDefault(require('antd-mobile/es/date-picker'));
require('antd-mobile/es/list/style/css');
var _List = _interopDefault(require('antd-mobile/es/list'));
require('antd/es/time-picker/style/css');
var _TimePicker = _interopDefault(require('antd/es/time-picker'));
require('antd/es/date-picker/style/css');
var _DatePicker = _interopDefault(require('antd/es/date-picker'));
var reactDateRange = require('react-date-range');

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
//,Calendar as CalendarMobile 
var RangePicker = _DatePicker.RangePicker;
var TimePickerRangePicker = _TimePicker.RangePicker;
var Option = _Select.Option;

var DateTimeComponent = function DateTimeComponent(props) {
  var _props$inputProps = props.inputProps,
      placeholder = _props$inputProps.placeholder,
      picker = _props$inputProps.picker,
      value = _props$inputProps.value,
      scope = _props$inputProps.scope,
      inputProps = props.inputProps,
      _props$fieldConfig = props.fieldConfig,
      type = _props$fieldConfig.type,
      is24 = _props$fieldConfig.is24,
      isMobile = props.fns.isMobile,
      style = props.qnnformData.style;

  var _useState = React.useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      calendarMobileShow = _useState2[0],
      setCalendarMobileShow = _useState2[1];

  var comProps = _objectSpread({
    locale: {
      DatePickerLocale: {
        year: "年",
        month: "月",
        day: "日",
        hour: "时",
        minute: "分"
      },
      okText: "确定",
      dismissText: "取消"
    }
  }, inputProps, {
    //因为不同组件值取得不一样，所以需要转换好传回去
    onChange: function onChange(val) {
      if (scope) {
        inputProps.onChange(_objectSpread({
          scope: "0"
        }, value, {
          value: new Date(val).getTime()
        }), props);
      } else {
        inputProps.onChange(new Date(val).getTime(), props);
      }
    }
  });

  if (isMobile()) {
    //注意：移动端某些组件使用的是pc端的组件
    var ListItemClassName = "".concat(style.mobileDatePickerListItem, " mobileDatePickerListItem"); // const now = new Date();

    switch (type) {
      case "time":
      case "date":
      case "datetime":
      case "year":
      case "month":
        //移动端组件传入picker居然有影响...
        delete comProps.picker; //日期需要格式化一下

        comProps.value = comProps.value ? new Date(comProps.value) : null;
        comProps.extra = React__default.createElement("span", {
          style: {
            color: "#c9c9c9"
          }
        }, placeholder); //年月特殊格式化

        if (type === "year") {
          comProps.format = function (val) {
            return moment(val).format("YYYY");
          };
        } else if (type === "month") {
          comProps.format = function (val) {
            return moment(val).format("YYYY-MM");
          };
        }

        return React__default.createElement(_DatePicker2, _extends({
          mode: type
        }, comProps), React__default.createElement(_List.Item, {
          arrow: "horizontal",
          className: ListItemClassName
        }));
      //使用pc端组件

      case "week":
        //pc端为moment格式
        comProps.onChange = function (val) {
          return inputProps.onChange(val, props);
        };

        return React__default.createElement(_DatePicker, _extends({}, inputProps, {
          picker: type
        }));

      case "rangeDate":
        //time year month week 使用pc端的组件
        if (picker === "time" || picker === "week" || picker === "month" || picker === "year") {
          //pc端为moment格式
          comProps.onChange = function (val) {
            return inputProps.onChange(val, props);
          }; //日期需要格式化一下


          if (comProps.value) {
            comProps.value = [moment(comProps.value[0]), moment(comProps.value[1])];
          }

          return picker === "time" ? React__default.createElement(TimePickerRangePicker, comProps) : React__default.createElement(RangePicker, comProps);
        } else {
          comProps.extra = React__default.createElement("span", {
            style: {
              color: "#c9c9c9"
            }
          }, placeholder.join('~')); // console.log(value)

          return React__default.createElement("div", {
            className: "".concat(style.DateRangeMobile, " DateRangeMobile")
          }, React__default.createElement(_List.Item, {
            onClick: function onClick() {
              return setCalendarMobileShow(true);
            },
            arrow: "horizontal",
            className: ListItemClassName
          }, React__default.createElement("div", {
            className: "am-list-extra"
          }, value && value.length ? "".concat(moment(value === null || value === void 0 ? void 0 : value[0]).format('YYYY-MM-DD'), " ~ ").concat(moment(value === null || value === void 0 ? void 0 : value[1]).format('YYYY-MM-DD')) : comProps.extra)), calendarMobileShow ? React__default.createElement("div", null, React__default.createElement(reactDateRange.DateRange, {
            rangeColors: ["red", "blue"],
            startDate: moment(value === null || value === void 0 ? void 0 : value[0]),
            endDate: moment(value === null || value === void 0 ? void 0 : value[1]),
            lang: "cn",
            calendars: 1,
            moveRangeOnFirstSelection: false,
            onChange: function onChange(val) {
              inputProps.onChange([val.startDate, val.endDate], props);
            }
          }), React__default.createElement("div", {
            onClick: function onClick() {
              return setCalendarMobileShow(false);
            },
            className: "".concat(style.dateRangeMobileBtn, " dateRangeMobileBtn")
          }, "\u786E\u5B9A")) : null);
        }

      default:
        return React__default.createElement("span", null, "\u6682\u4E0D\u652F\u6301\u7C7B\u578B", type, ", \u8BF7\u67E5\u9605\u6587\u6863");
    }
  } else {
    //pc端为moment格式
    comProps.onChange = function (val) {
      if (scope) {
        inputProps.onChange(_objectSpread({
          scope: "0"
        }, value, {
          value: val
        }), props);
      } else {
        inputProps.onChange(val, props);
      }
    }; //日期需要格式化一下


    if (comProps.value) {
      if (scope) {
        comProps.value = moment(value.value);
      } else {
        comProps.value = type === "rangeDate" ? [moment(comProps.value[0]), moment(comProps.value[1])] : moment(comProps.value);
      }
    } //时间日期组件需要显示时间选择
    //其他格式的无需显示时间但是需要指定picker


    if (type === "datetime") {
      comProps.showTime = true;
    } else {
      comProps.picker = picker || type; //区间选择采取的是picker 其他日期组件使用type
    } //范围选择


    var scopeDom = React__default.createElement(_Select, {
      value: (value === null || value === void 0 ? void 0 : value.scope) || "0",
      disabled: !value || !value.value,
      style: {
        width: "65px",
        marginRight: '3px',
        textAlign: "center"
      },
      onChange: function onChange(val) {
        //没有值不需要执行这个change方法
        (value === null || value === void 0 ? void 0 : value.value) && (inputProps === null || inputProps === void 0 ? void 0 : inputProps.onChange(_objectSpread({}, inputProps === null || inputProps === void 0 ? void 0 : inputProps.value, {
          scope: val
        }), props));
      }
    }, React__default.createElement(Option, {
      value: "0",
      style: {
        textAlign: "center"
      }
    }, "="), React__default.createElement(Option, {
      value: "1"
    }, "<="), React__default.createElement(Option, {
      value: "2"
    }, ">=")); //时间日期选择

    var DateDome = null;

    switch (type) {
      case "time":
        DateDome = React__default.createElement(_TimePicker, comProps);
        break;

      case "date":
      case "month":
      case "year":
      case "week":
      case "datetime":
        //默认为24小时制
        if (is24 === false) {
          comProps.format = "YYYY-MM-DD hh:mm:ss";
        }

        DateDome = React__default.createElement(_DatePicker, comProps);
        break;

      case "rangeDate":
        DateDome = picker === "time" ? React__default.createElement(TimePickerRangePicker, comProps) : React__default.createElement(RangePicker, comProps);
        break;

      default:
        DateDome = React__default.createElement("span", null, "\u6682\u4E0D\u652F\u6301\u7C7B\u578B", type, ", \u8BF7\u67E5\u9605\u6587\u6863");
        break;
    } //如果需要添加范围选择需处理


    var NewDateDome = DateDome;

    if (scope) {
      NewDateDome = React__default.createElement("div", {
        className: style.DateScope
      }, React__default.createElement("div", null, scopeDom), React__default.createElement("div", {
        className: style.DateContaiiner
      }, DateDome));
    }

    return NewDateDome;
  }
};

exports.default = DateTimeComponent;
