'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

function _interopNamespace(e) {
    if (e && e.__esModule) { return e; } else {
        var n = {};
        if (e) {
            Object.keys(e).forEach(function (k) {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () {
                        return e[k];
                    }
                });
            });
        }
        n['default'] = e;
        return n;
    }
}

require('./export-0fe6e142.js');
require('./array-method-has-species-support-9edd0ecd.js');
require('./object-keys-bdc20d04.js');
require('./web.dom-collections.for-each-e2b90693.js');
require('./create-property-2dfb33b0.js');
require('./array-method-uses-to-length-11844004.js');
require('./es.array.concat-2cd183db.js');
require('./es.array.index-of-5554a592.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.function.name-154a69d5.js');
require('./es.object.assign-7fe0379a.js');
require('./es.object.define-property-aad2ae5c.js');
var React = require('react');
var React__default = _interopDefault(React);
require('./es.promise-14a9b921.js');
require('./species-constructor-ccbb5326.js');
require('./es.array.map-0663019f.js');
require('antd/es/skeleton/style/css');
var _Skeleton = _interopDefault(require('antd/es/skeleton'));
require('antd/es/tabs/style/css');
var _Tabs = _interopDefault(require('antd/es/tabs'));

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var QnnTableComponent = React__default.lazy(function () {
  return new Promise(function (resolve) { resolve(_interopNamespace(require('qnn-table'))); });
});
var TabPane = _Tabs.TabPane;

var TabsForm = function TabsForm(props) {
  var qnnformData = props.qnnformData,
      _props$qnnformData = props.qnnformData,
      _props$qnnformData$ta = _props$qnnformData.tabs,
      tabs = _props$qnnformData$ta === void 0 ? [] : _props$qnnformData$ta,
      tabsIndex = _props$qnnformData.tabsIndex,
      style = _props$qnnformData.style,
      headers = _props$qnnformData.headers,
      _props$qnnformData$qn = _props$qnnformData.qnnFormProps,
      qnnFormProps = _props$qnnformData$qn === void 0 ? {} : _props$qnnformData$qn,
      _props$fns = props.fns,
      bind = _props$fns.bind,
      BindComKey = _props$fns.BindComKey,
      setTabsIndex = _props$fns.setTabsIndex,
      fetch = _props$fns.fetch,
      fns = props.fns,
      funcCallBackParams = props.funcCallBackParams,
      form = props.form,
      BasicForm = props.BasicForm,
      CreateFormItemEle = props.CreateFormItemEle,
      getForm = props.getForm; //如果是配置了fetchConfig需要去请求值
  //如果是qnnForm类型的表单需要将值赋值到表单

  var callback = function callback(key) {
    tabs[key].onShow && bind(tabs[key].onShow)(funcCallBackParams({
      form: form
    }));
    setTabsIndex(key);
  };

  return React__default.createElement("div", {
    className: "".concat(style.TabsContainer, " TabsContainer")
  }, React__default.createElement(_Tabs, {
    defaultActiveKey: tabsIndex,
    onChange: callback,
    activeKey: tabsIndex,
    className: "".concat(style.Tabs, " Tabs")
  }, tabs.map(function (tabItem, index) {
    var type = tabItem.type,
        name = tabItem.name,
        field = tabItem.field,
        title = tabItem.title,
        content = tabItem.content,
        disabled = tabItem.disabled,
        otherArgs = _objectWithoutProperties(tabItem, ["type", "name", "field", "title", "content", "disabled"]);

    var _type = type || name; //兼容写法
    // tab props


    var itemBasicFormProps = {
      fns: fns,
      form: form,
      getForm: getForm,
      CreateFormItemEle: CreateFormItemEle,
      funcCallBackParams: funcCallBackParams,
      //需要注意：qnnformData是主qnnForm组件的配置 tabFormConfig是具体的某一个tab的qnnForm配置
      tabFormConfig: _objectSpread({}, content),
      qnnformData: qnnformData
    };
    return React__default.createElement(TabPane, _extends({
      tab: title,
      key: index.toString(),
      disabled: bind(disabled)(funcCallBackParams()) // style={{ height: tabContextHeight}}
      //在一定的情况下需要预渲染别的表单
      //需要验证别的tabs下的表单项
      ,
      forceRender: _type === "qnnForm" ? true : false
    }, otherArgs, {
      className: "".concat(otherArgs.className, " ").concat(style.TabPane, " TabPane ").concat(_type !== "qnnForm" ? style.TabPaneByNoForm : "")
    }), function () {
      if (_type === "qnnForm") {
        return React__default.createElement(React.Suspense, {
          fallback: React__default.createElement(_Skeleton, null)
        }, React__default.createElement(BasicForm, itemBasicFormProps));
      } else if (_type === "qnnTable") {
        return React__default.createElement(React.Suspense, {
          fallback: React__default.createElement(_Skeleton, null)
        }, React__default.createElement("div", {
          className: "".concat(style.TabByqnnTable, " TabByqnnTable")
        }, React__default.createElement(QnnTableComponent, _extends({
          fetch: fetch,
          headers: headers,
          disabled: bind(content.disabled)(funcCallBackParams()) //这里前期设计错误  这么传入数据后期污染很大

        }, qnnFormProps, {
          parentProps: _objectSpread({}, qnnFormProps, {
            form: form
          }),
          tabs: [],
          fetchConfig: null
        }, content, {
          antd: _objectSpread({
            size: 'small'
          }, content.antd)
        }))));
      } else {
        return React__default.createElement(BindComKey, funcCallBackParams({
          form: form
        }), content);
      }
    }());
  })));
};

exports.default = TabsForm;
