import './export-027d82a1.js';
import './array-method-has-species-support-b7707cf8.js';
import './object-keys-7927f237.js';
import './web.dom-collections.for-each-c618c184.js';
import './create-property-83edbfea.js';
import './array-method-uses-to-length-0113804b.js';
import './web.dom-collections.iterator-af7c468d.js';
import './es.array.concat-829cff0b.js';
import './es.object.to-string-7d545381.js';
import './es.regexp.to-string-c88b21e1.js';
import './es.object.define-property-1edb513c.js';
import './es.string.match-a2f9805d.js';
import 'antd/es/spin/style/css';
import _Spin from 'antd/es/spin';
import React from 'react';
import './es.promise-c5e2079e.js';
import './species-constructor-a207edf9.js';
import './es.array.map-1861e9db.js';
import './runtime-ce4fc2ab.js';
import { F as FechInc } from './FetchInc-b8790ec7.js';
import 'antd/es/radio/style/css';
import _Radio from 'antd/es/radio';
import 'antd/es/checkbox/style/css';
import _Checkbox from 'antd/es/checkbox';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var CheckboxGroup = _Checkbox.Group;
var RadioGroup = _Radio.Group; //单选和多选都是用该组件

var CheckboxComponent = function CheckboxComponent(props) {
  var inputProps = props.inputProps,
      type = props.fieldConfig.type,
      style = props.qnnformData.style;
  return React.createElement(FechInc, props, function (fetchIncProps) {
    var fetchOptionDataIng = fetchIncProps.fetchOptionDataIng,
        fetchOptionDataEd = fetchIncProps.fetchOptionDataEd,
        _fetchIncProps$option = fetchIncProps.optionConfig,
        label = _fetchIncProps$option.label,
        value = _fetchIncProps$option.value,
        disabled = _fetchIncProps$option.disabled,
        _fetchIncProps$option2 = fetchIncProps.optionData,
        optionData = _fetchIncProps$option2 === void 0 ? [] : _fetchIncProps$option2,
        fetchData = fetchIncProps.fetchData; //这两确认判断不可少

    !fetchOptionDataIng && !fetchOptionDataEd && fetchData();

    var commProps = _objectSpread({}, inputProps, {
      className: "".concat(inputProps.className, " ").concat(style.qnnFormCheckbox, " qnnFormCheckbox"),
      options: optionData.map(function (item) {
        item.label = item[label];
        item.value = item[value];
        item.disabled = item[disabled];
        return item;
      }),
      onChange: function onChange(v) {
        var val = v.target ? v.target.value : v;
        var itemData = (Array.isArray(val) ? val : [val]).map(function (item) {
          return optionData.filter(function (optionDataItem) {
            return optionDataItem.value === item;
          })[0];
        });
        inputProps.onChange(val, {
          itemData: itemData
        });
      }
    });

    if (type === "checkbox") {
      return React.createElement(_Spin, {
        spinning: fetchOptionDataIng,
        tip: "loading"
      }, React.createElement(CheckboxGroup, commProps));
    } else if (type === "radio") {
      return React.createElement(_Spin, {
        spinning: fetchOptionDataIng,
        tip: "loading"
      }, React.createElement(RadioGroup, commProps));
    }
  });
};

export default CheckboxComponent;
