import { F as requireObjectCoercible, g as global, $ } from './export-027d82a1.js';
import './array-method-has-species-support-b7707cf8.js';
import './object-keys-7927f237.js';
import './web.dom-collections.for-each-c618c184.js';
import './create-property-83edbfea.js';
import './array-method-uses-to-length-0113804b.js';
import './web.dom-collections.iterator-af7c468d.js';
import './es.array.concat-829cff0b.js';
import './es.object.to-string-7d545381.js';
import './es.object.assign-751f539a.js';
import './es.object.define-property-1edb513c.js';
import './es.object.set-prototype-of-c8244b29.js';
import React, { Component } from 'react';
import './es.array.map-1861e9db.js';
import './es.array.splice-157fd807.js';
import 'antd/es/input/style/css';
import _Input from 'antd/es/input';
import 'antd/es/button/style/css';
import _Button from 'antd/es/button';
import { CloseOutlined, PlusCircleOutlined } from '@ant-design/icons';

// a string of all valid unicode whitespaces
// eslint-disable-next-line max-len
var whitespaces = '\u0009\u000A\u000B\u000C\u000D\u0020\u00A0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF';

var whitespace = '[' + whitespaces + ']';
var ltrim = RegExp('^' + whitespace + whitespace + '*');
var rtrim = RegExp(whitespace + whitespace + '*$');

// `String.prototype.{ trim, trimStart, trimEnd, trimLeft, trimRight }` methods implementation
var createMethod = function (TYPE) {
  return function ($this) {
    var string = String(requireObjectCoercible($this));
    if (TYPE & 1) string = string.replace(ltrim, '');
    if (TYPE & 2) string = string.replace(rtrim, '');
    return string;
  };
};

var stringTrim = {
  // `String.prototype.{ trimLeft, trimStart }` methods
  // https://tc39.github.io/ecma262/#sec-string.prototype.trimstart
  start: createMethod(1),
  // `String.prototype.{ trimRight, trimEnd }` methods
  // https://tc39.github.io/ecma262/#sec-string.prototype.trimend
  end: createMethod(2),
  // `String.prototype.trim` method
  // https://tc39.github.io/ecma262/#sec-string.prototype.trim
  trim: createMethod(3)
};

var trim = stringTrim.trim;


var $parseInt = global.parseInt;
var hex = /^[+-]?0[Xx]/;
var FORCED = $parseInt(whitespaces + '08') !== 8 || $parseInt(whitespaces + '0x16') !== 22;

// `parseInt` method
// https://tc39.github.io/ecma262/#sec-parseint-string-radix
var numberParseInt = FORCED ? function parseInt(string, radix) {
  var S = trim(String(string));
  return $parseInt(S, (radix >>> 0) || (hex.test(S) ? 16 : 10));
} : $parseInt;

// `parseInt` method
// https://tc39.github.io/ecma262/#sec-parseint-string-radix
$({ global: true, forced: parseInt != numberParseInt }, {
  parseInt: numberParseInt
});

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var index =
/*#__PURE__*/
function (_Component) {
  _inherits(index, _Component);

  function index() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, index);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(index)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      value: _this.props.value || [],
      disabled: _this.props.disabled,
      addLabel: _this.props.addLabel || "添加"
    };

    _this.addBtn = function () {
      var _this$state$value = _this.state.value,
          value = _this$state$value === void 0 ? [] : _this$state$value;

      if (!value) {
        value = [];
      }

      var obj = {
        label: "",
        id: value.length
      };
      value.push(obj);

      if (_this.props.onChange) {
        var _value = value.map(function (item) {
          return item.label;
        });

        _this.props.onChange(_value);
      }

      _this.setState({
        value: value
      });
    };

    _this.getAfter = function (index) {
      return _this.props.getAfter ? _this.props.getAfter(index) : String.fromCharCode(64 + parseInt(index + 1, 10));
    };

    return _this;
  }

  _createClass(index, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state = this.state,
          _this$state$value2 = _this$state.value,
          value = _this$state$value2 === void 0 ? [] : _this$state$value2,
          _this$state$disabled = _this$state.disabled,
          disabled = _this$state$disabled === void 0 ? false : _this$state$disabled,
          addLabel = _this$state.addLabel;
      var _this$props = this.props,
          style = _this$props.qnnformData.style,
          className = _this$props.className;
      return React.createElement("div", {
        className: "".concat(className, " ").concat(style.qnnFormItemCom, " qnnFormItemCom")
      }, value && value.map(function (item, index) {
        var label = item.label,
            _item$id = item.id,
            id = _item$id === void 0 ? {
          index: index
        } : _item$id;
        return React.createElement("div", {
          key: index,
          style: {
            marginBottom: "6px"
          }
        }, React.createElement(_Input, {
          onChange: function onChange(val) {
            val = val.target.value;
            var value = _this2.state.value;

            for (var i = 0; i < value.length; i++) {
              var _id = value[i].id;

              if (_id === id) {
                value[i].label = val;
              }
            }

            if (_this2.props.onChange) {
              var _value = value.map(function (item) {
                return item.label;
              });

              _this2.props.onChange(_value);
            }

            _this2.setState({
              value: value
            });
          },
          placeholder: _this2.props.placeholder || "请输入...",
          value: label,
          addonAfter: React.createElement("span", {
            onClick: function onClick() {
              var value = _this2.state.value;

              for (var i = 0; i < value.length; i++) {
                var _id = value[i].id;

                if (_id === id) {
                  value.splice(i, 1);
                }
              }

              if (_this2.props.onChange) {
                var _value = value.map(function (item) {
                  return item.label;
                });

                _this2.props.onChange(_value);
              }

              _this2.setState({
                value: value
              });
            },
            style: {
              color: "red",
              cursor: "pointer"
            }
          }, React.createElement(CloseOutlined, null)),
          addonBefore: React.createElement("span", null, _this2.getAfter(index))
        }));
      }), disabled ? null : React.createElement(_Button, {
        icon: React.createElement(PlusCircleOutlined, null),
        ghost: true,
        type: "primary",
        onClick: this.addBtn
      }, addLabel));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newObj = _objectSpread({}, prevState, {}, nextProps);

      if (newObj.value) {
        newObj.value = newObj.value.map(function (item, index) {
          return {
            id: index,
            label: item
          };
        });
      }

      return newObj;
    }
  }]);

  return index;
}(Component);

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var ItemComponent = function ItemComponent(props) {
  var inputProps = props.inputProps;
  return React.createElement(index, _extends({}, props, inputProps));
};

export default ItemComponent;
