'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('./export-0fe6e142.js');
require('./array-method-has-species-support-9edd0ecd.js');
require('./object-keys-bdc20d04.js');
require('./web.dom-collections.for-each-e2b90693.js');
require('./create-property-2dfb33b0.js');
require('./array-method-uses-to-length-11844004.js');
require('./web.dom-collections.iterator-4a803988.js');
require('./es.array.concat-2cd183db.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.object.define-property-aad2ae5c.js');
require('./es.string.match-ce60128e.js');
require('antd/es/spin/style/css');
var _Spin = _interopDefault(require('antd/es/spin'));
var React = require('react');
var React__default = _interopDefault(React);
require('./es.promise-14a9b921.js');
require('./species-constructor-ccbb5326.js');
require('./es.array.map-0663019f.js');
require('./runtime-72d72705.js');
var FetchInc = require('./FetchInc-49ecc47b.js');
require('antd/es/radio/style/css');
var _Radio = _interopDefault(require('antd/es/radio'));
require('antd/es/checkbox/style/css');
var _Checkbox = _interopDefault(require('antd/es/checkbox'));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var CheckboxGroup = _Checkbox.Group;
var RadioGroup = _Radio.Group; //单选和多选都是用该组件

var CheckboxComponent = function CheckboxComponent(props) {
  var inputProps = props.inputProps,
      type = props.fieldConfig.type,
      style = props.qnnformData.style;
  return React__default.createElement(FetchInc.FechInc, props, function (fetchIncProps) {
    var fetchOptionDataIng = fetchIncProps.fetchOptionDataIng,
        fetchOptionDataEd = fetchIncProps.fetchOptionDataEd,
        _fetchIncProps$option = fetchIncProps.optionConfig,
        label = _fetchIncProps$option.label,
        value = _fetchIncProps$option.value,
        disabled = _fetchIncProps$option.disabled,
        _fetchIncProps$option2 = fetchIncProps.optionData,
        optionData = _fetchIncProps$option2 === void 0 ? [] : _fetchIncProps$option2,
        fetchData = fetchIncProps.fetchData; //这两确认判断不可少

    !fetchOptionDataIng && !fetchOptionDataEd && fetchData();

    var commProps = _objectSpread({}, inputProps, {
      className: "".concat(inputProps.className, " ").concat(style.qnnFormCheckbox, " qnnFormCheckbox"),
      options: optionData.map(function (item) {
        item.label = item[label];
        item.value = item[value];
        item.disabled = item[disabled];
        return item;
      }),
      onChange: function onChange(v) {
        var val = v.target ? v.target.value : v;
        var itemData = (Array.isArray(val) ? val : [val]).map(function (item) {
          return optionData.filter(function (optionDataItem) {
            return optionDataItem.value === item;
          })[0];
        });
        inputProps.onChange(val, {
          itemData: itemData
        });
      }
    });

    if (type === "checkbox") {
      return React__default.createElement(_Spin, {
        spinning: fetchOptionDataIng,
        tip: "loading"
      }, React__default.createElement(CheckboxGroup, commProps));
    } else if (type === "radio") {
      return React__default.createElement(_Spin, {
        spinning: fetchOptionDataIng,
        tip: "loading"
      }, React__default.createElement(RadioGroup, commProps));
    }
  });
};

exports.default = CheckboxComponent;
