'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('./web.dom-collections.for-each-e2b90693.js');
require('./web.dom-collections.iterator-4a803988.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.object.define-property-aad2ae5c.js');
require('./es.string.match-ce60128e.js');
var React = require('react');
var React__default = _interopDefault(React);
require('./es.promise-14a9b921.js');
require('./runtime-72d72705.js');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
//用于层叠选择、多选、单选、

var FetchInc = function FetchInc(props) {
  //组件是否存在状态
  var isMonted = true;
  var fieldConfig = props.fieldConfig,
      optionConfig = props.fieldConfig.optionConfig,
      _props$fns = props.fns,
      tool = _props$fns.tool,
      fetch = _props$fns.fetch,
      bind = _props$fns.bind,
      form = props.form,
      match = props.qnnformData.match,
      funcCallBackParams = props.funcCallBackParams;
  var fetchConfig = fieldConfig.fetchConfig;

  var defaultOptionConfig = _objectSpread({
    label: "label",
    value: "value"
  }, optionConfig); //下拉数据和下拉数据kv配置


  var _useState = React.useState(fieldConfig.optionData),
      _useState2 = _slicedToArray(_useState, 2),
      optionData = _useState2[0],
      setOptionData = _useState2[1]; //是否正在请求下拉数据


  var _useState3 = React.useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      fetchOptionDataIng = _useState4[0],
      setFetchOptionDataIng = _useState4[1]; //是否已经请求过数据了(必须是请求成功了才算请求过)


  var _useState5 = React.useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      fetchOptionDataEd = _useState6[0],
      setFetchOptionDataEd = _useState6[1]; //[]变为了didMount 在return时是组件被销毁时候 


  var useWillUnmount = function useWillUnmount(fn) {
    return React.useEffect(function () {
      return function () {
        return fn && fn();
      };
    }, []);
  };

  useWillUnmount(function () {
    return isMonted = false;
  }); //请求数据的方法 

  var fetchData =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var apiName, params, otherParams, _body, _ref2, data, success, message;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!fetchConfig || !fetchConfig.apiName)) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return");

            case 2:
              apiName = fetchConfig.apiName, params = fetchConfig.params, otherParams = fetchConfig.otherParams;
              _body = tool.getFetchParams({
                params: params,
                otherParams: otherParams,
                match: match,
                form: form,
                bind: bind,
                funcCallBackParams: funcCallBackParams
              }); //开始请求 

              isMonted && setFetchOptionDataIng(true);
              _context.next = 7;
              return fetch(apiName, _body);

            case 7:
              _ref2 = _context.sent;
              data = _ref2.data;
              success = _ref2.success;
              message = _ref2.message;
              isMonted && setFetchOptionDataIng(false);

              if (success) {
                isMonted && setOptionData(data); //当非首次请求时候就无需重复设置fetchOptionDataEd了

                isMonted && !fetchOptionDataEd && setFetchOptionDataEd(true);
              } else {
                tool.msg.error(message);
              }

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function fetchData() {
      return _ref.apply(this, arguments);
    };
  }(); //触焦 请求数据


  var onFocus = function onFocus() {
    //当请求过了就不需要重新请求了
    !fetchOptionDataIng && !fetchOptionDataEd && fetchConfig && fetchConfig.apiName && isMonted && fetchData();
  };

  return React__default.cloneElement(React__default.createElement(props.children, null), {
    onFocus: onFocus,
    fetchData: fetchData,
    optionData: optionData,
    optionConfig: defaultOptionConfig,
    fetchOptionDataIng: fetchOptionDataIng,
    fetchOptionDataEd: fetchOptionDataEd
  });
};

exports.FechInc = FetchInc;
