'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

require('./export-0fe6e142.js');
require('./array-method-has-species-support-9edd0ecd.js');
require('./object-keys-bdc20d04.js');
require('./web.dom-collections.for-each-e2b90693.js');
require('./create-property-2dfb33b0.js');
require('./array-method-uses-to-length-11844004.js');
require('./web.dom-collections.iterator-4a803988.js');
require('./es.array.concat-2cd183db.js');
require('./es.array.index-of-5554a592.js');
require('./es.object.to-string-0ac89662.js');
require('./es.regexp.to-string-9e3df5de.js');
require('./es.function.name-154a69d5.js');
require('./es.object.assign-7fe0379a.js');
require('./es.object.define-property-aad2ae5c.js');
require('./es.object.set-prototype-of-0c1816f8.js');
require('./es.string.match-ce60128e.js');
require('antd/es/spin/style/css');
var _Spin = _interopDefault(require('antd/es/spin'));
var React = require('react');
var React__default = _interopDefault(React);
require('./es.promise-14a9b921.js');
require('./species-constructor-ccbb5326.js');
require('immutable');
require('react-router-dom');
require('moment');
require('pull-person');
require('pull-person-mobile');
require('qnn-tree');
var index$1 = require('./index-e3be4f77.js');
require('./es.array.map-0663019f.js');
require('antd/es/message/style/css');
require('antd/es/message');
require('./es.array.splice-58c5e38f.js');
require('./style-inject.es-17c48081.js');
require('./es.array.join-78b5edaa.js');
require('antd-mobile/es/toast/style/css');
require('antd-mobile/es/toast');
require('antd/es/notification/style/css');
require('antd/es/notification');
require('antd/es/modal/style/css');
require('antd/es/modal');
require('antd-mobile/es/modal/style/css');
require('antd-mobile/es/modal');
require('jquery');
require('./runtime-72d72705.js');
require('antd/es/pagination/style/css');
var _Pagination = _interopDefault(require('antd/es/pagination'));
require('antd/es/divider/style/css');
var _Divider = _interopDefault(require('antd/es/divider'));
require('antd/es/empty/style/css');
var _Empty = _interopDefault(require('antd/es/empty'));
require('antd/es/select/style/css');
var _Select = _interopDefault(require('antd/es/select'));

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Option = _Select.Option,
    OptGroup = _Select.OptGroup; //下拉组件

/*
    下拉组件只要有值没有下拉就需要去请求下拉选项数据，否则会显示一个id
    分页下拉则需要后台提供能根据下拉id获取下拉选项的下拉选项接口
*/

var SelectComponent = function SelectComponent(props) {
  var fieldConfig = props.fieldConfig,
      _props$fns = props.fns,
      fetch = _props$fns.fetch,
      tool = _props$fns.tool,
      bind = _props$fns.bind,
      _props$qnnformData = props.qnnformData,
      match = _props$qnnformData.match,
      formConfig = _props$qnnformData.formConfig,
      inputProps = props.inputProps,
      getSelectOptionFns = props.getSelectOptionFns,
      setSelectOptionFns = props.setSelectOptionFns,
      setSelectRender = props.setSelectRender,
      getSelectRender = props.getSelectRender,
      form = props.form,
      funcCallBackParams = props.funcCallBackParams; //组件是否存在状态

  var isMonted = true; //输入定时器

  var selectByPagingTimer;
  var fetchConfig = fieldConfig.fetchConfig,
      _fieldConfig$pageConf = fieldConfig.pageConfig,
      pageConfig = _fieldConfig$pageConf === void 0 ? {} : _fieldConfig$pageConf,
      parent = fieldConfig.parent,
      field = fieldConfig.field,
      optionDataGroup = fieldConfig.optionDataGroup;

  var defaultOptionConfig = _objectSpread({
    label: "label",
    value: "value"
  }, fieldConfig.optionConfig); //分页使用


  var defaultPageConfig = _objectSpread({
    limit: 10,
    page: 1
  }, pageConfig); //联动字段应该使用父级提供的option


  var defaultOption = parent ? getSelectOptionFns(Array.isArray(field) ? field.join('.') : field) : fieldConfig.optionData; //selectByPaging 带分页的下拉  select普通下拉

  var _useState = React.useState(fieldConfig.type),
      _useState2 = _slicedToArray(_useState, 1),
      type = _useState2[0]; //下拉数据和下拉数据kv配置


  var _useState3 = React.useState(defaultOption),
      _useState4 = _slicedToArray(_useState3, 2),
      optionData = _useState4[0],
      setOptionData = _useState4[1];

  var _useState5 = React.useState(_objectSpread({}, defaultOptionConfig)),
      _useState6 = _slicedToArray(_useState5, 1),
      optionConfig = _useState6[0]; //下拉分页使用的


  var _useState7 = React.useState(defaultPageConfig.limit),
      _useState8 = _slicedToArray(_useState7, 1),
      limit = _useState8[0];

  var _useState9 = React.useState(defaultPageConfig.page),
      _useState10 = _slicedToArray(_useState9, 2),
      page = _useState10[0],
      setPage = _useState10[1];

  var _useState11 = React.useState(0),
      _useState12 = _slicedToArray(_useState11, 2),
      totalNumber = _useState12[0],
      setTotalNumber = _useState12[1]; //分页下拉的搜索文字（普通下拉的搜索前端组件实现）


  var _useState13 = React.useState(null),
      _useState14 = _slicedToArray(_useState13, 2),
      searchText = _useState14[0],
      setSearchText = _useState14[1]; //是否正在请求下拉数据


  var _useState15 = React.useState(false),
      _useState16 = _slicedToArray(_useState15, 2),
      fetchOptionDataIng = _useState16[0],
      setFetchOptionDataIng = _useState16[1]; //是否已经请求过数据了(必须是请求成功了才算请求过)


  var _useState17 = React.useState(false),
      _useState18 = _slicedToArray(_useState17, 2),
      fetchOptionDataEd = _useState18[0],
      setFetchOptionDataEd = _useState18[1]; //是否是分页下拉组件的回显请求


  var _useState19 = React.useState(false),
      _useState20 = _slicedToArray(_useState19, 2),
      isPageSelectCallBackShow = _useState20[0],
      setIsPageSelectCallBackShow = _useState20[1]; //备份的下拉选项 在下拉分页切换时候会用到


  var _useState21 = React.useState({}),
      _useState22 = _slicedToArray(_useState21, 2),
      backUpOption = _useState22[0],
      setBackUpOption = _useState22[1]; //下拉选项key


  var label = optionConfig.label,
      value = optionConfig.value; //[]变为了didMount 在return时是组件被销毁时候 

  var useWillUnmount = function useWillUnmount(fn) {
    return React.useEffect(function () {
      return function () {
        return fn && fn();
      };
    }, []);
  };

  useWillUnmount(function () {
    return isMonted = false;
  }); // 分页改变后去请求数据 
  // 搜索文字改变后去搜索
  //必须是请求过之后才能生效，因为防止首次渲染

  React.useEffect(function () {
    fetchOptionDataEd && fetchData();
  }, [page, searchText]); //分页下拉回显需要根据下拉框的值去请求后台数据  （需要后台支持用下拉选项id去对下拉选项进行搜索）
  //非分页下拉直接请求全部下拉列表即可
  //只要是值变了就需要执行这个方法 因为设置值后没有下拉会显示id 

  React.useEffect(function () {
    if (!fetchOptionDataEd && inputProps.value && fetchConfig && fetchConfig.apiName) {
      if (type === "select") {
        fetchData();
      } else {
        //组件实例化后监听到值切换 并且 是分页下拉 并且没有下拉选项值时候
        //1、需要根据上面所述去请求后台下拉选项数据
        //2、请求来后世界上不能算请求过数据，只能算有了一个个显示的下拉选项，没有会显示一个id在输入框中
        //3、当用户触礁时候需要备份该下拉数据并且请求新的数据
        isMonted && setIsPageSelectCallBackShow(true);
        isMonted && fetchData(_defineProperty({}, value, inputProps.value));
      }
    }
  }, [inputProps.value]);
  React.useEffect(function () {
    //刷新方法其实就是设置下状态让组件重新渲染
    setSelectRender(Array.isArray(field) ? field.join('.') : field, function () {
      return isMonted && setOptionData(getSelectOptionFns(Array.isArray(field) ? field.join('.') : field));
    });
  }, []); //将字符串模板label绑定数据

  var getLabelByStrTmp = function getLabelByStrTmp(item) {
    var arrLabel = index$1.getStrTmp(label);
    var _labelArr = [];
    var joinStr = label;

    for (var i = 0; i < arrLabel.length; i++) {
      //去除掉{{}}便是字段
      var realVName = arrLabel[i].replace(/((\{\{)|(\}\}))/ig, '');

      _labelArr.push(item[realVName]); //去除掉字段设置后便是连接符号


      joinStr = joinStr.replace(arrLabel[i], '');
    }

    return _labelArr.join(joinStr);
  }; //根据下拉选项配置获取下拉选项的value数据
  //可以让value支持配置为数组 给后台时候使用逗号连接


  var getOptionItemValue = function getOptionItemValue(optionItem) {
    return Array.isArray(value) ? value.map(function (valueItemName) {
      return optionItem[valueItemName];
    }).join(",") : optionItem[value];
  }; //根据下拉选项配置获取下拉选项的label数据
  //可以让label支持使用字符串模板 "{{label}}>>{{ext1}}"


  var getOptionItemLabel = function getOptionItemLabel(optionItem) {
    return index$1.getStrTmp(label) ? getLabelByStrTmp(optionItem) : optionItem[label];
  }; //请求数据的方法
  //@_oParams用于去请求特定的一条数据 例如：回显时候显示第二页的值 这时候在在下拉选项中是没有第二页的数据的
  //@_oParams在分页下拉回显时候请求回显的下拉选项用的 


  var fetchData =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(_oParams) {
      var apiName, _fetchConfig$params, params, _fetchConfig$otherPar, otherParams, _fetchConfig$searchKe, searchKey, _body, _ref2, data, success, message, totalNumber, childrenFieldConfig, curSelectedOptiion;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              apiName = fetchConfig.apiName, _fetchConfig$params = fetchConfig.params, params = _fetchConfig$params === void 0 ? {} : _fetchConfig$params, _fetchConfig$otherPar = fetchConfig.otherParams, otherParams = _fetchConfig$otherPar === void 0 ? {} : _fetchConfig$otherPar, _fetchConfig$searchKe = fetchConfig.searchKey, searchKey = _fetchConfig$searchKe === void 0 ? "search" : _fetchConfig$searchKe;
              _body = tool.getFetchParams({
                params: params,
                otherParams: otherParams,
                match: match,
                form: form,
                bind: bind,
                funcCallBackParams: funcCallBackParams
              }); //分页下拉需要添加的请求参数

              if (type === "selectByPaging") {
                _body.limit = limit;
                _body.page = page;
                _body[searchKey] = searchText;
              } //请求特定值 分页插件用于回显


              if (_oParams) {
                _body = _objectSpread({
                  limit: limit,
                  page: 1
                }, _oParams);
              } //开始请求


              isMonted && setFetchOptionDataIng(true);
              _context.next = 7;
              return fetch(apiName, _body);

            case 7:
              _ref2 = _context.sent;
              data = _ref2.data;
              success = _ref2.success;
              message = _ref2.message;
              totalNumber = _ref2.totalNumber;
              isMonted && setFetchOptionDataIng(false);

              if (success) {
                isMonted && setOptionData(data);
                isMonted && setTotalNumber(totalNumber); // 一般是回显需要用到 需要为子集设置下拉选项

                childrenFieldConfig = tool.getChildren(formConfig, field);
                childrenFieldConfig && childrenFieldConfig.forEach(function (childFieldConfig) {
                  var realField = childFieldConfig.realField;
                  var childValue = form.getFieldValue(realField.split('.'));
                  var childOptionData = [];
                  var children = childFieldConfig.children || optionConfig.children;

                  var getOpteionData = function getOpteionData() {
                    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
                    var childValue = arguments.length > 1 ? arguments[1] : undefined;
                    data.forEach(function (item) {
                      if (item[value] === childValue) {
                        childOptionData = data;
                      } else if (item[children] && item[children].length) {
                        getOpteionData(item[children], childValue);
                      }
                    });
                  }; //获取到下拉数据


                  getOpteionData(data, childValue); //设置下拉数据

                  setSelectOptionFns(realField, childOptionData); //让子组件重新渲染

                  getSelectRender(realField)();
                }); //当非首次请求时候就无需重复设置fetchOptionDataEd了

                isMonted && !fetchOptionDataEd && !isPageSelectCallBackShow && setFetchOptionDataEd(true); //分页下拉回显时候备份回显的下拉选项

                if (type === "selectByPaging" && isPageSelectCallBackShow && isMonted) {
                  curSelectedOptiion = data.filter(function (item) {
                    return getOptionItemValue(item) === inputProps.value;
                  })[0]; //如果备份数据同数据列表中的数据重复的话情况备份选项即可  

                  if (curSelectedOptiion) {
                    isMonted && setBackUpOption({
                      label: getOptionItemLabel(curSelectedOptiion),
                      value: inputProps.value
                    });
                  }
                }
              } else {
                tool.msg.error(message);
              }

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function fetchData(_x) {
      return _ref.apply(this, arguments);
    };
  }(); //触焦 请求数据


  var onFocus = function onFocus() {
    //当请求过了就不需要重新请求了
    isMonted && isPageSelectCallBackShow && setIsPageSelectCallBackShow(false);
    !fetchOptionDataEd && fetchConfig && fetchConfig.apiName && fetchData(); //无限联动字段需要调用方法来获取下拉选项数据
    //理论上不会出现这种情况

    if (parent && !optionData && parent) {
      setOptionData(getSelectOptionFns(Array.isArray(field) ? field.join('.') : field));
    }
  }; //总数样式渲染


  var showTotal = function showTotal(total) {
    return "\u5171 ".concat(total, " \u6761\u6570\u636E");
  }; //分页切换


  var paginationChange = function paginationChange(page) {
    //分页切换后下拉选项实际上已经没了，所以会显示一个id
    if (inputProps.value) {
      var curSelectedOptiion = optionData.filter(function (item) {
        return getOptionItemValue(item) === inputProps.value;
      })[0]; //如果备份数据同数据列表中的数据重复的话情况备份选项即可  

      if (curSelectedOptiion) {
        setBackUpOption({
          label: getOptionItemLabel(curSelectedOptiion),
          value: inputProps.value
        });
      }
    } //设置分页


    setPage(page);
  }; //输入后的回调


  var handleSearch = function handleSearch(val) {
    selectByPagingTimer && clearTimeout(selectByPagingTimer);
    selectByPagingTimer = setTimeout(function () {
      //搜索文字后需要重置分页 
      setPage(1);
      setSearchText(val);
    }, 200);
  }; //是否需要显示备份的option数据


  var isNeedBackupOption = true;
  return React__default.createElement(_Select, _extends({
    loading: fetchOptionDataIng,
    onFocus: onFocus,
    onSearch: type === "selectByPaging" ? handleSearch : null //下拉分页自定义了下拉框，所以不需要notFoundContent，不然会出现两个loading的样式
    ,
    notFoundContent: fetchOptionDataIng && type !== "selectByPaging" ? React__default.createElement("div", {
      style: {
        textAlign: "center",
        padding: "24px 0px"
      }
    }, React__default.createElement(_Spin, {
      tip: "\u8BF7\u7A0D\u7B49..."
    })) : React__default.createElement(_Empty, {
      image: _Empty.PRESENTED_IMAGE_SIMPLE
    }) // 普通下拉不进行自定义渲染
    ,
    dropdownRender: type === "select" ? null : function (menu) {
      return React__default.createElement(_Spin, {
        spinning: fetchOptionDataIng,
        tip: "\u8BF7\u7A0D\u7B49..."
      }, menu, React__default.createElement(_Divider, {
        style: {
          margin: '4px 0'
        }
      }), React__default.createElement("div", {
        style: {
          padding: "8px 6px",
          textAlign: "right"
        }
      }, React__default.createElement(_Pagination, {
        current: page,
        onChange: paginationChange,
        pageSize: limit,
        size: "small",
        total: totalNumber,
        showTotal: showTotal
      })));
    }
  }, inputProps, {
    //解决回显值时候会显示id
    value: (optionData === null || optionData === void 0 ? void 0 : optionData.length) && inputProps.value ? inputProps.value : undefined
  }), optionData && optionData.map(function (item, index) {
    if (optionDataGroup) {
      var _item$children, _item$children$map;

      // 会存在开启数据分组 的情况 
      return React__default.createElement(OptGroup, {
        key: index,
        label: getOptionItemLabel(item)
      }, item === null || item === void 0 ? void 0 : (_item$children = item.children) === null || _item$children === void 0 ? void 0 : (_item$children$map = _item$children.map) === null || _item$children$map === void 0 ? void 0 : _item$children$map.call(_item$children, function (cItem, cIndex) {
        var v = getOptionItemValue(cItem);

        if (v === backUpOption.value) {
          isNeedBackupOption = false;
        }
        return React__default.createElement(Option, {
          key: "".concat(index, "-").concat(cIndex),
          value: v,
          itemdata: cItem,
          parentdata: item
        }, getOptionItemLabel(cItem));
      }));
    } else {
      var v = getOptionItemValue(item);

      if (v === backUpOption.value) {
        isNeedBackupOption = false;
      }
      return React__default.createElement(Option, {
        key: index,
        value: v,
        itemdata: item
      }, getOptionItemLabel(item));
    }
  }), inputProps.value && optionData && isNeedBackupOption && type === "selectByPaging" && backUpOption.label ? React__default.createElement(Option, {
    style: {
      color: "red",
      border: "1px solid red"
    },
    value: backUpOption.value
  }, backUpOption.label) : null);
};

exports.default = SelectComponent;
