import './export-027d82a1.js';
import './array-method-has-species-support-b7707cf8.js';
import './object-keys-7927f237.js';
import './web.dom-collections.for-each-c618c184.js';
import './create-property-83edbfea.js';
import './array-method-uses-to-length-0113804b.js';
import './es.array.concat-829cff0b.js';
import './es.array.index-of-030dd81b.js';
import './es.object.to-string-7d545381.js';
import './es.regexp.to-string-c88b21e1.js';
import './es.function.name-7013a2c1.js';
import './es.object.assign-751f539a.js';
import './es.object.define-property-1edb513c.js';
import React, { Suspense } from 'react';
import './es.promise-c5e2079e.js';
import './species-constructor-a207edf9.js';
import './es.array.map-1861e9db.js';
import 'antd/es/skeleton/style/css';
import _Skeleton from 'antd/es/skeleton';
import 'antd/es/tabs/style/css';
import _Tabs from 'antd/es/tabs';

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var QnnTableComponent = React.lazy(function () {
  return import('qnn-table');
});
var TabPane = _Tabs.TabPane;

var TabsForm = function TabsForm(props) {
  var qnnformData = props.qnnformData,
      _props$qnnformData = props.qnnformData,
      _props$qnnformData$ta = _props$qnnformData.tabs,
      tabs = _props$qnnformData$ta === void 0 ? [] : _props$qnnformData$ta,
      tabsIndex = _props$qnnformData.tabsIndex,
      style = _props$qnnformData.style,
      headers = _props$qnnformData.headers,
      _props$qnnformData$qn = _props$qnnformData.qnnFormProps,
      qnnFormProps = _props$qnnformData$qn === void 0 ? {} : _props$qnnformData$qn,
      _props$fns = props.fns,
      bind = _props$fns.bind,
      BindComKey = _props$fns.BindComKey,
      setTabsIndex = _props$fns.setTabsIndex,
      fetch = _props$fns.fetch,
      fns = props.fns,
      funcCallBackParams = props.funcCallBackParams,
      form = props.form,
      BasicForm = props.BasicForm,
      CreateFormItemEle = props.CreateFormItemEle,
      getForm = props.getForm; //如果是配置了fetchConfig需要去请求值
  //如果是qnnForm类型的表单需要将值赋值到表单

  var callback = function callback(key) {
    tabs[key].onShow && bind(tabs[key].onShow)(funcCallBackParams({
      form: form
    }));
    setTabsIndex(key);
  };

  return React.createElement("div", {
    className: "".concat(style.TabsContainer, " TabsContainer")
  }, React.createElement(_Tabs, {
    defaultActiveKey: tabsIndex,
    onChange: callback,
    activeKey: tabsIndex,
    className: "".concat(style.Tabs, " Tabs")
  }, tabs.map(function (tabItem, index) {
    var type = tabItem.type,
        name = tabItem.name,
        field = tabItem.field,
        title = tabItem.title,
        content = tabItem.content,
        disabled = tabItem.disabled,
        otherArgs = _objectWithoutProperties(tabItem, ["type", "name", "field", "title", "content", "disabled"]);

    var _type = type || name; //兼容写法
    // tab props


    var itemBasicFormProps = {
      fns: fns,
      form: form,
      getForm: getForm,
      CreateFormItemEle: CreateFormItemEle,
      funcCallBackParams: funcCallBackParams,
      //需要注意：qnnformData是主qnnForm组件的配置 tabFormConfig是具体的某一个tab的qnnForm配置
      tabFormConfig: _objectSpread({}, content),
      qnnformData: qnnformData
    };
    return React.createElement(TabPane, _extends({
      tab: title,
      key: index.toString(),
      disabled: bind(disabled)(funcCallBackParams()) // style={{ height: tabContextHeight}}
      //在一定的情况下需要预渲染别的表单
      //需要验证别的tabs下的表单项
      ,
      forceRender: _type === "qnnForm" ? true : false
    }, otherArgs, {
      className: "".concat(otherArgs.className, " ").concat(style.TabPane, " TabPane ").concat(_type !== "qnnForm" ? style.TabPaneByNoForm : "")
    }), function () {
      if (_type === "qnnForm") {
        return React.createElement(Suspense, {
          fallback: React.createElement(_Skeleton, null)
        }, React.createElement(BasicForm, itemBasicFormProps));
      } else if (_type === "qnnTable") {
        return React.createElement(Suspense, {
          fallback: React.createElement(_Skeleton, null)
        }, React.createElement("div", {
          className: "".concat(style.TabByqnnTable, " TabByqnnTable")
        }, React.createElement(QnnTableComponent, _extends({
          fetch: fetch,
          headers: headers,
          disabled: bind(content.disabled)(funcCallBackParams()) //这里前期设计错误  这么传入数据后期污染很大

        }, qnnFormProps, {
          parentProps: _objectSpread({}, qnnFormProps, {
            form: form
          }),
          tabs: [],
          fetchConfig: null
        }, content, {
          antd: _objectSpread({
            size: 'small'
          }, content.antd)
        }))));
      } else {
        return React.createElement(BindComKey, funcCallBackParams({
          form: form
        }), content);
      }
    }());
  })));
};

export default TabsForm;
